searchNodes=[{"doc":"","ref":"SortedSetKV.html","title":"SortedSetKV","type":"module"},{"doc":"","ref":"SortedSetKV.html#clear/1","title":"SortedSetKV.clear/1","type":"function"},{"doc":"","ref":"SortedSetKV.html#lpop/2","title":"SortedSetKV.lpop/2","type":"function"},{"doc":"","ref":"SortedSetKV.html#lpush/3","title":"SortedSetKV.lpush/3","type":"function"},{"doc":"","ref":"SortedSetKV.html#open/1","title":"SortedSetKV.open/1","type":"function"},{"doc":"","ref":"SortedSetKV.html#rpop/2","title":"SortedSetKV.rpop/2","type":"function"},{"doc":"","ref":"SortedSetKV.html#rpush/3","title":"SortedSetKV.rpush/3","type":"function"},{"doc":"","ref":"SortedSetKV.html#zadd/6","title":"SortedSetKV.zadd/6","type":"function"},{"doc":"","ref":"SortedSetKV.html#zexists/4","title":"SortedSetKV.zexists/4","type":"function"},{"doc":"","ref":"SortedSetKV.html#zgetbykey/4","title":"SortedSetKV.zgetbykey/4","type":"function"},{"doc":"","ref":"SortedSetKV.html#zrangebyprefixscore/7","title":"SortedSetKV.zrangebyprefixscore/7","type":"function"},{"doc":"","ref":"SortedSetKV.html#zrangebyscore/6","title":"SortedSetKV.zrangebyscore/6","type":"function"},{"doc":"","ref":"SortedSetKV.html#zrem/3","title":"SortedSetKV.zrem/3","type":"function"},{"doc":"","ref":"SortedSetKV.html#zrembyrangebyscore/5","title":"SortedSetKV.zrembyrangebyscore/5","type":"function"},{"doc":"","ref":"SortedSetKV.html#zscore/3","title":"SortedSetKV.zscore/3","type":"function"},{"doc":"","ref":"SortedSetKV.html#zscoreupdate/5","title":"SortedSetKV.zscoreupdate/5","type":"function"},{"doc":"Copyright (c) 2015-2020 Kyle Hanson Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the &quot;Software&quot;), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions: The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software. THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.","ref":"license.html","title":"License","type":"extras"},{"doc":"SortedSetKV An ultrafast double-ended queue, scored sorted set, and embedded key value database. Inspired by Redis's sorted sets, but quite different. Written for Elixir and backed by Rust's sled database. Think of it as a Key Value database with an optional secondary u64 index. Perfect for a TTL or timeseries. This is the basis of building a KV with a TTL, however I left it abstracted to be used like redis zadd with an optional value field and score field. This means you can use it like a set, use it like a KV, use it like a scored set, use it like a scored KV, or use it as a KV TTL. It is very versitile. And very fast. Everything is local, so you can get 1-4 times faster speeds than using Redis. Also because you control the TLL, it won't auto evict things. This is very different from Redis which will start evicting keys regardless if their TTL has passed when it runs out of memory. SortedSetKV is stored on disk and can grow beyond your RAM limit. There is no GenServer abstraction and calls are made directly to Rust.","ref":"readme.html","title":"Overview","type":"extras"},{"doc":"This is alpha software and the API can change in the future.","ref":"readme.html#disclaimer","title":"Overview - Disclaimer","type":"extras"},{"doc":"SortedSetKV can be installed by adding :sorted_set_kv to your list of dependencies in mix.exs : def deps do [ { :sorted_set_kv , &quot;~&gt; 0.1.0&quot; } ] end","ref":"readme.html#installation","title":"Overview - Installation","type":"extras"},{"doc":"{ :ok , db } = SortedSetKV . open ( &quot;mypath&quot; ) # Add a key to a set, with a value and a score. # The last parameter tells to only add if the old score is less than new score. :ok = SortedSetKV . zadd ( db , &quot;mycollection&quot; , &quot;hello&quot; , &quot;world&quot; , 42 , true ) :ok = SortedSetKV . zadd ( db , &quot;mycollection&quot; , &quot;foo&quot; , &quot;bar&quot; , 420 , true ) :ok = SortedSetKV . zadd ( db , &quot;mycollection&quot; , &quot;noscore&quot; , &quot;&quot; , nil , true ) :ok = SortedSetKV . zadd ( db , &quot;mycollection&quot; , &quot;novalue&quot; , nil , 100 , true ) # Returns whether it exists and its score { true , 42 } = SortedSetKV . zscore ( db , &quot;mycollection&quot; , &quot;hello&quot; ) { true , 420 } = SortedSetKV . zscore ( db , &quot;mycollection&quot; , &quot;foo&quot; ) { true , nil } = SortedSetKV . zscore ( db , &quot;mycollection&quot; , &quot;noscore&quot; ) { true , 100 } = SortedSetKV . zscore ( db , &quot;mycollection&quot; , &quot;novalue&quot; ) # A key must have a score or a value to exist: :ok = SortedSetKV . zadd ( db , &quot;mycollection&quot; , &quot;noexists&quot; , nil , nil , true ) { false , nil } = SortedSetKV . zscore ( db , &quot;mycollection&quot; , &quot;noexists&quot; )","ref":"readme.html#basic-usage","title":"Overview - Basic Usage","type":"extras"},{"doc":"# Get a key with a minimum score { value , score } = SortedSetKV . zgetbykey ( db , &quot;mycollection&quot; , &quot;hello&quot; , 0 ) # A key with a score lower than the minscore will return nil nil = SortedSetKV . zgetbykey ( db , &quot;mycollection&quot; , &quot;foo&quot; , 500 ) # see if any keys exist with the score true = SortedSetKV . zexists ( db , &quot;mycollection&quot; , 0 , 500 )","ref":"readme.html#retrieving-values","title":"Overview - Retrieving Values","type":"extras"},{"doc":"With zadd and zupdate , you can optionally only update the score if the new score is greater than the old score or if the old score is not set. :ok = SortedSetKV . zadd ( db , &quot;mycollection&quot; , &quot;hello&quot; , &quot;world&quot; , 42 , true ) { &quot;world&quot; , 42 } = SortedSetKV . zgetbykey ( db , &quot;mycollection&quot; , &quot;hello&quot; , 0 ) :ok = SortedSetKV . zadd ( db , &quot;mycollection&quot; , &quot;hello&quot; , &quot;value2&quot; , 0 , true ) # only adds if the score is greather than { &quot;world&quot; , 42 } = SortedSetKV . zgetbykey ( db , &quot;mycollection&quot; , &quot;hello&quot; , 0 ) :ok = SortedSetKV . zscoreupdate ( db , &quot;mycollection&quot; , &quot;hello&quot; , 0 , true ) { &quot;world&quot; , 42 } = SortedSetKV . zgetbykey ( db , &quot;mycollection&quot; , &quot;hello&quot; , 0 ) # Setting the value to false overrides this :ok = SortedSetKV . zadd ( db , &quot;mycollection&quot; , &quot;hello&quot; , &quot;value2&quot; , 10 , false ) { &quot;value2&quot; , 10 } = SortedSetKV . zgetbykey ( db , &quot;mycollection&quot; , &quot;hello&quot; , 0 ) :ok = SortedSetKV . zscoreupdate ( db , &quot;mycollection&quot; , &quot;hello&quot; , 0 , false ) { &quot;value2&quot; , 0 } = SortedSetKV . zgetbykey ( db , &quot;mycollection&quot; , &quot;hello&quot; , 0 )","ref":"readme.html#conditional-add","title":"Overview - Conditional Add","type":"extras"},{"doc":"offset = 0 limit = 100 [ &quot;hello&quot; ] = SortedSetKV . zrangebyscore ( db , &quot;mycollection&quot; , 0 , 50 , offset , limit ) # Filter by prefix and score [ &quot;foo&quot; ] = SortedSetKV . zrangebyprefixscore ( db , &quot;mycollection&quot; , &quot;fo&quot; , 0 , 500 , offset , limit )","ref":"readme.html#iterating-keys-with-scores","title":"Overview - Iterating keys with scores","type":"extras"},{"doc":"# Remove key :ok = SortedSetKV . zrem ( db , &quot;mycollection&quot; , &quot;hello&quot; ) # Remove all keys by score and returns how many it deleted _ = SortedSetKV . zrembyrangebyscore ( db , &quot;mycollection&quot; , 0 , 500 , limit )","ref":"readme.html#removing-values","title":"Overview - Removing Values","type":"extras"},{"doc":":ok = SortedSetKV . rpush ( db , &quot;mylist&quot; , &quot;value&quot; ) &quot;value&quot; = SortedSetKV . lpop ( db , &quot;mylist&quot; ) nil = SortedSetKV . lpop ( db , &quot;mylist&quot; ) :ok = SortedSetKV . rpush ( db , &quot;mylist&quot; , &quot;1&quot; ) :ok = SortedSetKV . rpush ( db , &quot;mylist&quot; , &quot;2&quot; ) :ok = SortedSetKV . lpush ( db , &quot;mylist&quot; , &quot;0&quot; ) &quot;0&quot; = SortedSetKV . lpop ( db , &quot;mylist&quot; ) &quot;2&quot; = SortedSetKV . rpop ( db , &quot;mylist&quot; )","ref":"readme.html#queue","title":"Overview - Queue","type":"extras"},{"doc":"If you use millisecond timestamps as the score, it behaves like a TTL. { :ok , db } = SortedSetKV . open ( &quot;mypath&quot; ) # Add a key to a set, with a value and a score :ok = SortedSetKV . zadd ( db , &quot;mycollection&quot; , &quot;hello&quot; , &quot;world&quot; , :os . system_time ( :millisecond ) + 5000 ) # Get key only if it is in TTL SortedSetKV . zgetbykey ( db , &quot;mycollection&quot; , &quot;foo&quot; , :os . system_time ( :millisecond ) ) # Clean up exipired Keys SortedSetKV . zrembyrangebyscore ( db , &quot;mycollection&quot; , 0 , :os . system_time ( :millisecond ) ) You can use a GenServer like this to customize your TTL cleanup. Because Elixir executes all Rust Nifs on one thread, you will not want to block for very long. It is wise to only delete a few keys at a time. defmodule TTLCleanup do use GenServer require Logger @review_time 5_000 def start_link ( conn ) do GenServer . start_link ( __MODULE__ , conn , [ ] ) end def init ( conn ) do Process . send_after ( self ( ) , :review_storage , @review_time ) { :ok , conn } end def handle_info ( :review_storage , conn ) do Logger . debug ( &quot;TTL cleanup&quot; ) :ok = scan ( conn , &quot;collection1&quot; ) :ok = scan ( conn , &quot;collection2&quot; ) :ok = scan ( conn , &quot;collection3&quot; ) Process . send_after ( self ( ) , :review_storage , @review_time ) { :noreply , conn } end def scan ( conn , collection ) do new_agg = SortedSetKV . zrembyrangebyscore ( conn , collection , 0 , :os . system_time ( :millisecond ) , 100 ) case new_agg do v when is_number ( v ) and v &lt;= 99 -&gt; :ok v when is_number ( v ) -&gt; scan ( conn , collection ) end end end","ref":"readme.html#ttl","title":"Overview - TTL","type":"extras"}]